% plots (iwmrrf companion code)
% by Christian Himpe, 2015 ( http://gramian.de )
% released under BSD 2-Clause License ( opensource.org/licenses/BSD-2-Clause )
%

load('iwmrrf.mat');


% TSRK
figure();

subplot(1,3,1);
plot(4.^(1:POINTS),TIMINGS(:,3),'b','linewidth',2); hold on;
plot(4.^(1:POINTS),TIMINGS(:,4),'r','linewidth',2); hold off;
legend('RK3','IRK3');
xlabel('State Dimension');
ylabel('Time [s]');
xlim([4,4^POINTS(end)]);

subplot(1,3,2);
plot(4.^(1:POINTS),TIMINGS(:,1),'b','linewidth',2); hold on;
plot(4.^(1:POINTS),TIMINGS(:,5),'r','linewidth',2); hold off;
legend('W_J (RK3)','W_J (IRK3)');
xlabel('State Dimension');
ylabel('Time [s]');
xlim([4,4^POINTS(end)]);

subplot(1,3,3);
semilogy(4.^(1:POINTS),NORMS(:,1),'c','linewidth',2); hold on;
semilogy(4.^(1:POINTS),NORMS(:,2),'m','linewidth',2); hold off;
legend('WX Error (HS)','WI Error (HS)');
xlabel('State Dimension');
ylabel('Gramian Error');
xlim([4,4^POINTS(end)]);


% GENTRANSP
figure();

plot(4.^(1:POINTS),TIMINGS(:,1),'b','linewidth',2); hold on;
plot(4.^(1:POINTS),TIMINGS(:,7),'r','linewidth',2); hold off;
legend('W_J (DOT)','W_J (GT)');
xlabel('State Dimension');
ylabel('Time [s]');
xlim([4,4^POINTS(end)]);


% AINV
figure();

subplot(1,3,1);
plot(4.^(1:POINTS),TIMINGS(:,9),'b','linewidth',2); hold on;
plot(4.^(1:POINTS),TIMINGS(:,10),'r','linewidth',2); hold off;
legend('INV','AINV');
xlabel('State Dimension');
ylabel('Time [s]');
xlim([4,4^POINTS(end)]);

subplot(1,3,2);
plot(4.^(1:POINTS),TIMINGS(:,1),'b','linewidth',2); hold on;
plot(4.^(1:POINTS),TIMINGS(:,5),'r','linewidth',2); hold off;
legend('W_J (INV)','W_J (AINV)');
xlabel('State Dimension');
ylabel('Time [s]');
xlim([4,4^POINTS(end)]);

subplot(1,3,3);
semilogy(4.^(1:POINTS),NORMS(:,3),'m','linewidth',2);
legend('WI Error (HS)');
xlabel('State Dimension');
ylabel('Gramian Error');
xlim([4,4^POINTS(end)]);


% LSVD
figure();

plot(4.^(1:POINTS),TIMINGS(:,13),'b','linewidth',2); hold on;
plot(4.^(1:POINTS),TIMINGS(:,14),'g','linewidth',2);
plot(4.^(1:POINTS),TIMINGS(:,15),'r','linewidth',2); hold off;
legend('SVDS','EIGS','LSVD');
xlabel('State Dimension');
ylabel('Time [s]');
xlim([4,4^POINTS(end)]);


% OLDvNEW
figure();

subplot(1,2,1);
plot(4.^(1:POINTS),TIMINGS(:,1),'b','linewidth',2); hold on;
plot(4.^(1:POINTS),TIMINGS(:,17),'r','linewidth',2); hold off;
legend('W_J (OLD)','W_J (NEW)');
xlabel('State Dimension');
ylabel('Time [s]');
xlim([4,4^POINTS(end)]);

subplot(1,2,2);
semilogy(4.^(1:POINTS),NORMS(:,4),'c','linewidth',2); hold on;
semilogy(4.^(1:POINTS),NORMS(:,5),'m','linewidth',2); hold off;
legend('WX Error (HS)','WI Error (HS)');
xlabel('State Dimension');
ylabel('Gramian Error');
xlim([4,4^POINTS(end)]);

